//
// Created by philipp on 15.01.18.
//

#include "../include/Socket.h"

namespace networking
{
namespace socket
{
namespace internal
{

bool stringFromBuffer(std::string & data, std::vector<char> & buffer, std::size_t bytesTransferred)
{
    if (bytesTransferred < 4)
        return false;

    auto numDataBytes = utils::fromBigEndian<4, std::uint32_t>((const std::uint8_t *) buffer.data());
    if (bytesTransferred < 4 + numDataBytes)
        return false;

    data = std::string{buffer.begin() + 4,
                       buffer.begin() + 4 + numDataBytes};
    return true;
}

}
}
}